
-- Finished game 1 (Fairy-Max 5.0 vs Arminius 2017 RND): 1-0 {White mates}
-- Finished game 2 (Moustique 0.3 vs NEG 0.3): 1/2-1/2 {Draw by stalemate}
-- Finished game 7 (Cheng3 1.06 vs Fridolin 2.00): 1/2-1/2 {Draw by 3-fold repetition}
-- Finished game 6 (SlowChess Blitz WV21 vs SlowChess Classic 1.6): 1/2-1/2 {Draw by fifty moves rule}
-- Finished game 16 (Fridolin 2.00 vs Wing 1.3): 1/2-1/2 {Draw by insufficient mating material}
-- Finished game 3 (Nemeton 1.61 vs Arminius 2017 RND): 0-1 {White makes an illegal move: c7d8}
-- Finished game 3 (Cheng3 1.06 vs Dragon 4.6): 0-1 {White loses on time}
-- Finished game 16 (Fridolin 2.00 vs Dragon 4.6): 1-0 {Black resigns}
-- Finished game 19 (NG-Play 9.87 vs Nero 6.1): 1-0 {White wins by adjudication: black claims illegal move: time 6000}
-- Finished game 1 (Sachy 0.2.03 vs Nero 6.0): 1-0 {White wins by adjudication: black claims illegal move: rejected analyze}
-- Finished game 10 (Ram 2.0 vs Xadreco 5.72): 1-0 {Black disconnects}
-- Finished game 2 (Ram 2.0 vs Micro-Max 3.2): 1-0 {Black's connection stalls}
-- Warning: Unexpected move from "Wing 1.5"
-- Warning: Illegal PV move c4b5 from SlowChess Blitz 0

function ListFiles(AMask)
  local LIndex, LResult = 0, {}
  for LLine in io.popen('find ' .. AMask .. ' -type f -name "*.log"'):lines() do
    LIndex = LIndex + 1
    LResult[LIndex] = LLine
  end
  return LResult
end

local LFiles = ListFiles('./games/')

os.execute('mkdir -p incidents')

local LFileIM = io.open("incidents/illegal.txt", "w")
local LFileOT = io.open("incidents/time.txt", "w")
local LFileDC = io.open("incidents/disconnects.txt", "w")
local LFileCS = io.open("incidents/stalls.txt", "w")

LFileIM:write(string.format("+%s+%s+%s+%s+\n", string.rep("=", 16), string.rep("=", 6), string.rep("=", 27), string.rep("=", 7)))
LFileOT:write(string.format("+%s+%s+%s+\n", string.rep("=", 16), string.rep("=", 6), string.rep("=", 27)))
LFileDC:write(string.format("+%s+%s+%s+\n", string.rep("=", 16), string.rep("=", 6), string.rep("=", 27)))
LFileCS:write(string.format("+%s+%s+%s+\n", string.rep("=", 16), string.rep("=", 6), string.rep("=", 27)))

LFileIM:write(string.format("| %-14s | %-4s | %-25s | %-5s |\n", "File", "Game", "Engine", "Move"))
LFileOT:write(string.format("| %-14s | %-4s | %-25s |\n", "File", "Game", "Engine"))
LFileDC:write(string.format("| %-14s | %-4s | %-25s |\n", "File", "Game", "Engine"))
LFileCS:write(string.format("| %-14s | %-4s | %-25s |\n", "File", "Game", "Engine"))

LFileIM:write(string.format("+%s+%s+%s+%s+\n", string.rep("=", 16), string.rep("=", 6), string.rep("=", 27), string.rep("=", 7)))
LFileOT:write(string.format("+%s+%s+%s+\n", string.rep("=", 16), string.rep("=", 6), string.rep("=", 27)))
LFileDC:write(string.format("+%s+%s+%s+\n", string.rep("=", 16), string.rep("=", 6), string.rep("=", 27)))
LFileCS:write(string.format("+%s+%s+%s+\n", string.rep("=", 16), string.rep("=", 6), string.rep("=", 27)))

for LIdx = 1, #LFiles do
  --print(LFiles[LIdx])
  for LLine in io.lines(LFiles[LIdx]) do
    local LNumber, LWhiteName, LBlackName, LResult, LComment = string.match(LLine, "Finished game (%d+) %((.+) vs (.+)%): (.+) {(.+)}")
    if LNumber then
      if LComment:match("illegal move") then
        local LEngine = LComment:match("White makes") and LWhiteName or LBlackName
        local LMove = string.gsub(LComment, ".+: (.+)", "%1")
        LFileIM:write(string.format("| %14s | %4s | %-25s | %-5s |\n", LFiles[LIdx]:match("%d+"), LNumber, LEngine, LMove))
      elseif LComment:match("on time") then
        local LEngine = LComment:match("White loses") and LWhiteName or LBlackName
        LFileOT:write(string.format("| %14s | %4s | %-25s |\n", LFiles[LIdx]:match("%d+"), LNumber, LEngine))
      elseif LComment:match("disconnects") then
        local LEngine = LComment:match("White") and LWhiteName or LBlackName
        LFileDC:write(string.format("| %14s | %4s | %-25s |\n", LFiles[LIdx]:match("%d+"), LNumber, LEngine))
      elseif LComment:match("connection stalls") then
        local LEngine = LComment:match("White") and LWhiteName or LBlackName
        LFileCS:write(string.format("| %14s | %4s | %-25s |\n", LFiles[LIdx]:match("%d+"), LNumber, LEngine))
      end
    end
  end
end

LFileIM:close()
LFileOT:close()
LFileDC:close()
LFileCS:close()
